from abc import ABC, abstractmethod

from cpl_query.extension.list import List

from parser.abc.ast import AST
from lexer.model.token import Token

class ParserABC(ABC):

    @abstractmethod
    def __init__(self): pass

    @abstractmethod
    def create_ast(self, tokens: List[Token]) -> List[AST]: pass
